***************************************
* author Brunello Pulix
*        Cagliari (Italy)
*        brunellopulix@yahoo.it
*        placed in the public domain
***************************************
#include <hmg.ch>
#include <fileio.ch>
#include <common.ch>
*
# define OLE_DOC  0
# define OLE_HTML 8
# define OLE_DOCX 16
# define OLE_XML  11
# define OLE_PDF  17
# define OLE_XPS  18
*
Declare Window Main
*
Procedure GetImageFromRtf(cPath,cFile)
   Local nHandle
   Local aTemp
   Local i
   Local n1
   Local n2
   Local oFile
   Local c1
   Local c2
   *
   aTemp := {}
   n1    := 0
   n2    := 0
   *
   oFile := TFileRead():New( cPath+cFile+'.Rtf' )
   oFile:Open()
   DO WHILE oFile:MoreToRead()
      aadd(aTemp,oFile:ReadLine())
   ENDDO
   oFile:Close()
   *
   nHandle     := FCreate(cPath+cFile+'.Txt')
   For i := 1 To Len(aTemp)
      If '{\pict' $ aTemp[i]
         Fwrite(nHandle,Substr(aTemp[i],at('{\pict',aTemp[i]))+CRLF)
         n1 := i
         exit
      Endif
   Next
   *
   For i := n1+1 To Len(aTemp)-5
       Fwrite(nHandle,aTemp[i]+CRLF)
   Next
   c1 := ''
   n2 := Len(aTemp)-5
   For i := n2+1 To Len(aTemp)
       c1 += aTemp[i]
   Next
   *
   c2 := left(c1,at('}}',c1))
   if Substr(c2,Len(c2),1) != '}'
      c2 += '}'
   endif
   Fwrite(nHandle,c2)
   FClose(nHandle)
   *
Return
*
Procedure ExtractWallpaperFromRtf(cPath,cFile)
   Local nHandle
   Local aTemp
   Local i
   Local n1
   Local n2
   Local oFile
   *
   aTemp := {}
   n1    := 0
   n2    := 0
   *
   oFile := TFileRead():New( cPath+cFile+'.Rtf' )
   oFile:Open()
   DO WHILE oFile:MoreToRead()
      aadd(aTemp,oFile:ReadLine())
   ENDDO
   oFile:Close()
   *
   nHandle     := FCreate(cPath+cFile+'.Txt')
   For i := 1 To Len(aTemp)
      If '{\*\generator' $ aTemp[i]
         Fwrite(nHandle,Substr(aTemp[i],at('{\*\generator',aTemp[i]))+CRLF)
         n1 := i
         exit
      Endif
   Next
   *
   n2 := Len(aTemp)
   For i := n1+1 To n2
      If i == n2
         aTemp[i] := left(aTemp[i],at('}}',aTemp[i]))
         if Substr(aTemp[i],Len(aTemp[i]),1) != '}'
            aTemp[i] += '}'
         endif
         Fwrite(nHandle,aTemp[i]+CRLF)
         exit
      Else
         Fwrite(nHandle,aTemp[i]+CRLF)
      endif
   Next
   FClose(nHandle)
   *
Return
*
Procedure RUN_WORD(cFile)
Local cOut,cCaption
*
If Main.RadioGroup_1.Value > 4 .and. Word_Version < 12
   MsgInfo('.....Word Version too old!!!.....')
   Return
Endif
*
cCaption := Main.RadioGroup_1.Caption(Main.RadioGroup_1.Value)
*
cFile := Upper(cFile)
If cCaption  == [RTF]
   // default rtf
elseIf cCaption  == [DOCX]
   cOut   := StrTran(cFile,'.RTF','_DOCX_.DOCX')
   RUN_OLE(cFile,cOut,OLE_DOCX)
   Ferase(cFile)
   cFile := cOut
elseIf cCaption  == [DOC]
   cOut   := StrTran(cFile,'.RTF','_DOC_.DOC')
   RUN_OLE(cFile,cOut,OLE_DOC)
   Ferase(cFile)
   cFile := cOut
elseIf cCaption  == [HTML]
   cOut   := StrTran(cFile,'.RTF','_HTML_.HTML')
   RUN_OLE(cFile,cOut,OLE_HTML)
   Ferase(cFile)
   cFile := cOut
elseIf cCaption  == [XML]
   cOut   := StrTran(cFile,'.RTF','_XML_.XML')
   RUN_OLE(cFile,cOut,OLE_XML)
   Ferase(cFile)
   cFile := cOut
elseIf cCaption  == [PDF]
   cOut   := StrTran(cFile,'.RTF','_PDF_.PDF')
   RUN_OLE(cFile,cOut,OLE_PDF)
   Ferase(cFile)
   cFile := cOut
elseIf cCaption  == [XPS]
   cOut   := StrTran(cFile,'.RTF','_XPS_.XPS')
   RUN_OLE(cFile,cOut,OLE_PDF)
   Ferase(cFile)
   cFile := cOut
Endif
*
ShellExecute(,"Open",cFile,'',,0)
*
Return
*
Procedure RUN_OLE(cRtf,cOut,n,cMess)
Local oWord,oFile
*
Default cMess To '.......Please wait......'
*
WAIT WINDOW cMess NOWAIT
oWord := CreateObject( "Word.Application" )
oFile := oWord:Documents:Open(cRtf)
oFile:SaveAs(cOut,n)
oWord:quit()
WAIT CLEAR
*
Return
*
FUNCTION WordVersion()
LOCAL oWord
LOCAL xRet
*
xRet := 0
oWord := CreateObject("Word.Application")
xRet  := val(oWord:Version)
oWord:quit()
*****************************
*"95"   Version =   "7.0"
*"97"   Version =   "8.0"
*"2000" Version =   "9.0"
*"2002" Version =   "10.0"
*"2003" Version =   "11.0"
*"2007" Version =   "12.0"
*"2010" Version =   "14.0"
*****************************
RETURN xRet
*
Procedure ExtractWordartFromRtf(cPath,cFile)
   Local nHandle
   Local aTemp
   Local i
   Local n0
   Local n1
   Local n2
   Local n3
   Local oFile
   Local c1
   *
   GetImageFromRtf(cPath,cFile)
   *
   aTemp := {}
   n0    := 0
   n1    := 0
   n2    := 0
   n3    := 0
   *
   oFile := TFileRead():New( cPath+cFile+'.Txt' )
   oFile:Open()
   DO WHILE oFile:MoreToRead()
      aadd(aTemp,oFile:ReadLine())
   ENDDO
   oFile:Close()
   *
   nHandle     := FCreate(cPath+'~Temp2')
   For i := 1 To Len(aTemp)
      If '{\*\themedata' $ aTemp[i]
         Fwrite(nHandle,Substr(aTemp[i],at('{\*\themedata',aTemp[i]))+CRLF)
         n1 := i
         n0 := i
         exit
      Endif
   Next
   *
   c1 := ''
   For i := n1+1 To Len(aTemp)
       If '{\*\colorschememapping' $ aTemp[i]
           c1 += substr(aTemp[i],AT('{\*\colorschememapping',aTemp[i]))
           n2 := i
           exit
       else
           Fwrite(nHandle,aTemp[i]+CRLF)
       endif
   Next
   *
   For i := n2+1 To Len(aTemp)
       c1 += aTemp[i]
   Next
   Fwrite(nHandle,left(c1,AT('}',c1))+CRLF)
   *
   FClose(nHandle)
   Ferase(cPath+cFile+'.Txt')
   *
   nHandle     := FCreate(cPath+'~Temp1')
   *
   For i := 1 To n0-10
       Fwrite(nHandle,aTemp[i]+CRLF)
   Next
   n3 := i
   c1 := ''
   For i := n3+1 To n0
       c1 += aTemp[i]
   Next
   Fwrite(nHandle,left(c1,AT('}',c1))+CRLF)
   FClose(nHandle)
   *
   nHandle     := FCreate(cPath+cFile+'.Txt')
   *
   oFile := TFileRead():New(cPath+'~Temp1' )
   oFile:Open()
   DO WHILE oFile:MoreToRead()
      Fwrite(nHandle,oFile:ReadLine())
   ENDDO
   oFile:Close()
   *
   Fwrite(nHandle,CRLF)
   *
   oFile := TFileRead():New(cPath+'~Temp2' )
   oFile:Open()
   DO WHILE oFile:MoreToRead()
      Fwrite(nHandle,oFile:ReadLine())
   ENDDO
   oFile:Close()
   *
   FClose(nHandle)
   *
   Ferase(cPath+'~Temp1')
   Ferase(cPath+'~Temp2')
   *
Return
*
Procedure ExtractPasswordFromRtf(cPath,cFile)
   Local nHandle
   Local aTemp
   Local i
   Local n1
   Local n2
   Local oFile
   Local c1
   Local c2
   *
   aTemp := {}
   n1    := 0
   n2    := 0
   *
   oFile := TFileRead():New( cPath+cFile+'.Rtf' )
   oFile:Open()
   DO WHILE oFile:MoreToRead()
      aadd(aTemp,oFile:ReadLine())
   ENDDO
   oFile:Close()
   *
   nHandle     := FCreate(cPath+cFile+'.Txt')
   Fwrite(nHandle,'\annotprot'+CRLF)
   For i := 1 To Len(aTemp)
      If '{\*\passwordhash' $ aTemp[i]
         Fwrite(nHandle,Substr(aTemp[i],at('{\*\passwordhash',aTemp[i]))+CRLF)
         n1 := i
         exit
      Endif
   Next
   *
   For i := n1+1 To Len(aTemp)
      If '{\*\colorschememapping' $ aTemp[i]
          Fwrite(nHandle,left(aTemp[i],at('{\*\colorschememapping',aTemp[i])-1)+CRLF)
          exit
      else
          Fwrite(nHandle,aTemp[i]+CRLF)
      endif
   Next
   FClose(nHandle)
   *
Return
*
Function ArToSt(aArray, cDelim)
   Local cList := '', ny
   For ny := 1 To Len(aArray)
      cDelim := IF( ny < Len(aArray), cDelim, '')
      cList  := cList + aArray[ny] + cDelim
   Next
Return cList
*
Function StToAr(cList,cDelim)
   Local aArray := {}, nPos
   Do While .T.
      nPos := AT( cDelim, cList )
      IF nPos > 0
         aadd( aArray, SubStr( cList, 1, nPos - 1 ))
         cList := SubStr( cList, nPos + 1 )
      Else
         EXIT
      Endif
   Enddo
   aadd( aArray, cList )
Return aArray
*
Function StToAr2(cList)
Local aArray := {}, i
*
For i := 1 To Len(cList)
    aadd( aArray, SubStr( cList, i,1 ))
Next
*
Return aArray
*
